package xic.analysis;

import java.util.Set;

import xic.ir.IRNode;
import xic.ir.StructHashSet;

public class AnticipatedExpressions extends AvailableExpressions {
	public AnticipatedExpressions(Set<CFGNode> nodes) {
		super(nodes);
		dir = Direction.BACKWARD;
		top = new ExprValue(); 
	}
	
	public StructHashSet<IRNode> in(CFGNode node) {
		AvailExprInfo info = (AvailExprInfo) flowInfo.get(node);
		return ((ExprValue) info.exit).exprs;
	}

	public StructHashSet<IRNode> out(CFGNode node) {
		AvailExprInfo info = (AvailExprInfo)flowInfo.get(node);
		return ((ExprValue) info.entry).exprs;
	}


	@Override
	protected void F(FlowInfo f) {
		AvailExprInfo fi = (AvailExprInfo) f;
		
		StructHashSet<IRNode> entry = ((ExprValue) f.entry).exprs;
		StructHashSet<IRNode> exit = ((ExprValue) f.exit).exprs;

		exit.clear();
		exit.addAll(entry);
		removeKill(fi.kill, exit);
		exit.addAll(fi.eval); 
	}	
}
