package xic.analysis;

import java.util.Set;

import xic.analysis.AvailableExpressions.ExprValue;
import xic.ir.IRNode;
import xic.ir.StructHashSet;


public class Isolated extends DataFlowAnalysis {
	private Latestness lateExpr;
	private AnticipatedExpressions ae;

	public class IsolatedFlowInfo extends FlowInfo {
		StructHashSet<IRNode> eval, latein;
		CFGNode node;
		public IsolatedFlowInfo(CFGNode n) {
			entry = new ExprValue();
			exit = new ExprValue();
			eval = ae.eval(n);
			latein = lateExpr.in(n);
			node = n;
		}
	};
	
	public Isolated(Set<CFGNode> nodes, CFGNode entry,
			AnticipatedExpressions ae,
			Latestness lateExpr) {
		super(nodes);
		this.lateExpr = lateExpr;
		this.ae = ae;
		this.top = new ExprValue();
		dir = Direction.BACKWARD;
		/*XXX: is this necessary? */ 
		initFlowInfo();
	}

	public StructHashSet<IRNode> in(CFGNode node) {
		IsolatedFlowInfo info = (IsolatedFlowInfo) flowInfo.get(node);
		return ((ExprValue) info.exit).exprs;
	}
	
	public StructHashSet<IRNode> out(CFGNode node) {
		IsolatedFlowInfo info = (IsolatedFlowInfo) flowInfo.get(node);
		return ((ExprValue) info.entry).exprs;
	}

	protected FlowInfo createFlowInfo(CFGNode node) {
		return new IsolatedFlowInfo(node);
	}

	protected void F(FlowInfo f) {
		IsolatedFlowInfo fi = (IsolatedFlowInfo) f;

		StructHashSet<IRNode> entry = ((ExprValue) f.entry).exprs;
		StructHashSet<IRNode> exit = ((ExprValue) f.exit).exprs;
			
		exit.clear();
		exit.addAll(entry);
		exit.removeAll(fi.eval);
		exit.addAll(fi.latein);
	}
}
