package xic.analysis;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import xic.ir.IRNode;
import xic.ir.StructHashSet;


public class Latestness {
	private Map<CFGNode, StructHashSet<IRNode>> values;

	public Latestness(Set<CFGNode> nodes, AnticipatedExpressions antExpr, Delayedness del) {
		values = new HashMap<CFGNode, StructHashSet<IRNode>>();

		for (CFGNode n : nodes) {
			StructHashSet<IRNode> result = new StructHashSet<IRNode>(antExpr.allExprs);

			StructHashSet<IRNode> intersection = new StructHashSet<IRNode>(antExpr.allExprs);
			for (CFGNode succ : n.outEdges())
				intersection.retainAll(del.in(succ));
			
			result.removeAll(intersection);
			result.addAll(antExpr.eval(n));
			result.retainAll(del.in(n));
			values.put(n, result);
		}
	}

	public StructHashSet<IRNode> in(CFGNode node) {
		return values.get(node);
	}
}