package xic.codegen.matchers;

import java.util.ArrayList;
import java.util.List;

import xic.codegen.AbstractTile;
import xic.codegen.InstrList;
import xic.codegen.Matcher;
import xic.codegen.Tile;
import xic.codegen.Tiler;
import xic.ir.IRCompUnit;
import xic.ir.IRFuncDecl;
import xic.ir.IRNode;
import xic.ir.NameGenerator;


public class CompUnitMatcher implements Matcher {
	protected static class CompUnitTile extends AbstractTile {
		public CompUnitTile(List<Tile> children) {
			this.children.addAll(children);
		}

		public int localCost() {
			return 0;
		}

		public String translate(InstrList il, NameGenerator ng) {
			for (Tile tile : children)
				tile.translate(il, ng);
			return null;
		}
	};

	public Tile match(IRNode node, Tiler tiler) {
		if (!(node instanceof IRCompUnit))
			return null;

		IRCompUnit cu = (IRCompUnit) node;
		List<Tile> children = new ArrayList<Tile>();
		for (IRFuncDecl func : cu.functions().values())
			children.add(tiler.tile(func));
		
		if (cu.hasExtraSequence())
			children.add(tiler.tile(cu.extraSequence()));

		return new CompUnitTile(children);
	}
}