package xic.codegen.matchers;

import xic.codegen.InstrList;
import xic.codegen.LabelInstr;
import xic.codegen.Matcher;
import xic.codegen.Tile;
import xic.codegen.Tiler;
import xic.ir.IRLabel;
import xic.ir.IRNode;
import xic.ir.NameGenerator;

public class LabelMatcher implements Matcher {
	public Tile match(IRNode node, Tiler tiler) {
		if (!(node instanceof IRLabel))
			return null;

		final String name = ((IRLabel) node).name();
		return new Tile() {
			public int estimateCost() {
				return 0;
			}
			
			public String translate(InstrList il, NameGenerator ng) {
				il.add(new LabelInstr(name));
				return null;
			}
		};
	}
}
