package xic.ir;

import java.util.Set;

import xic.ast.ASTNode;
import xic.ast.Copyable;
import xic.visitors.NodeVisitor;


public class IRCtor extends IRStmt {
	private String name;

	public IRCtor(String name) {
		this.name = name;
	}

	public String name() {
		return name;
	}
	
    public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}
    
    public Copyable copy() {
		return new IRCtor(name);
    }

    public Copyable deepCopy() {
		return new IRCtor(name);
    }

    public int computeMaximumCallArguments() {
		return 0;
	}

	public int computeMaximumCallResults() {
		return 0;		
	}

    public boolean containsCalls() {
    	return false;
    }

    public boolean containsMemReads() {
    	return false;
    }
	public boolean containsNonParamMemReads() {
		return false;
	}

    public boolean containsMemWrites() {
    	return false;
    }

	public void findReadTemps(Set<String> tempNames) {
	}

	public void findWrittenTemps(Set<String> tempNames) {
	}	
	
	public int nodeCount() {
		return 1;
	}

	public String label() {
		return "CTOR(\""+name+"\")";
	}

	public boolean equalsTree(Object object) {
		if (!(object instanceof IRCtor))
			return false;

		IRCtor other = (IRCtor) object;
		return other.name.equals(name);
	}

	public int treeHashCode() {
		int code=17;
		code = code * 37 + name.hashCode();
		return code;
	}
}