package xic.ir;

import java.util.Set;

import xic.ast.ASTNode;
import xic.ast.Copyable;
import xic.visitors.NodeVisitor;


public class IRName extends IRExpr {
	private String name;

	public IRName(String name) {
		this.name = name;
	}
	
	public String name() {
		return name;
	}

	public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}

	public boolean containsCalls() {
		return false;
	}

	public boolean containsMemReads() {
		return false;
	}

	public boolean containsNonParamMemReads() {
		return false;
	}
	public boolean containsMemWrites() {
		return false;
	}

	public void findReadTemps(Set<String> tempNames) {
	}

	public void findWrittenTemps(Set<String> tempNames) {
	}
	
	public int computeMaximumCallArguments() {
		return 0;
	}

	public int computeMaximumCallResults() {
		return 0;		
	}

	public int nodeCount() {
		return 1;
	}

	public String label() {
		return "NAME(" + name + ")";
	}

	public Copyable copy() {
		return new IRName(name);
	}

	public Copyable deepCopy() {
		return new IRName(name);
	}

	public boolean equalsTree(Object object) {
		if (!(object instanceof IRName))
			return false;
		return ((IRName) object).name.equals(name);
	}
	
	public int treeHashCode() {
		return name.hashCode();
	}
}
