package xic.ir;

import java.util.Set;

import xic.ast.ASTNode;
import xic.ast.Copyable;
import xic.visitors.NodeVisitor;


public class IRZData extends IRStmt {
	private String name;
	private int size;

	public IRZData(String name, int size) {
		this.name = name;
		this.size = size;
	}

	public String name() {
		return name;
	}
	
	public int size() {
		return size;
	}

    public ASTNode visitChildren(NodeVisitor v) {
		return this;
	}
    
    public Copyable copy() {
		return new IRZData(name, size);
    }

    public Copyable deepCopy() {
		return new IRZData(name, size);
    }

    public boolean containsCalls() {
    	return false;
    }

    public boolean containsMemReads() {
    	return false;
    }
	public boolean containsNonParamMemReads() {
		return false;
	}

    public boolean containsMemWrites() {
    	return false;
    }

	public void findReadTemps(Set<String> tempNames) {
	}

	public void findWrittenTemps(Set<String> tempNames) {
	}	
	
	public int computeMaximumCallArguments() {
		return 0;
	}

	public int computeMaximumCallResults() {
		return 0;		
	}

	public int nodeCount() {
		return 1;
	}

	public String label() {
		return "ZDATA(\""+name+"\", "+size+")";
	}

	public boolean equalsTree(Object object) {
		if (!(object instanceof IRZData))
			return false;

		IRZData other = (IRZData) object;
		return other.name.equals(name) && other.size == size;
	}

	public int treeHashCode() {
		int code=17;
		code = code * 37 + name.hashCode();
		code = code * 37 + size;
		return code;
	}
}
