package xic.lexer;


public class CharacterToken extends BaseToken {
	protected char charValue;
	
	public CharacterToken(int type, String value, char charValue, String unit, int line, int column, int length) {
		super(type, value, unit, line, column, length);
		this.charValue = charValue;
	}

	public char charValue() {
		return charValue;
	}

	public boolean equals(Object obj) {
		if (obj.getClass() != CharacterToken.class)
			return false;
		CharacterToken other = (CharacterToken) obj;
		return super.equals(other) && other.charValue == charValue;
	}

	public int hashCode() {
		return 37*super.hashCode() + (int) charValue;
	}
}
